#include "Texture.h"


// eNX`[̓ǂݍ
bool LoadTexture(const WCHAR* pFileName, TextureData* pOut)
{
	if( pOut == NULL ) return false;
	IDirect3DTexture9* pTexture;
	D3DXIMAGE_INFO info;
	// t@CeNX`[𐶐
	HRESULT hr = D3DXCreateTextureFromFileEx(
		GetDirect3DDevice(),	// Direct3DDevice
		pFileName,				// t@C
		D3DX_DEFAULT,			// (D3DX_DEFAULTŃt@C画)
		D3DX_DEFAULT,			// (D3DX_DEFAULTŃt@C画)
		1,						// ~bv}bv̐
		0,						// gppr
		D3DFMT_A8R8G8B8,		// tH[}bg
		D3DPOOL_MANAGED,		// ̊Ǘݒ
		D3DX_FILTER_NONE,		// tB^[ݒ
		D3DX_DEFAULT,			// ~bv}bvtB^[̐ݒ
		0x00000000,				// J[L[
		&info,					// 摜
		NULL,					// pbgf[^
		&pTexture);				// eNX`[̊i[
	if( FAILED(hr) )
	{
		return false;
	}
	D3DSURFACE_DESC desc;
	// eNX`[̏擾
	pTexture->GetLevelDesc(0, &desc);
	// eNX`[̐ݒ
	pOut->pTexture	= pTexture;
	pOut->srcWidth	= info.Width;
	pOut->srcHeight	= info.Height;
	pOut->width		= desc.Width;
	pOut->height	= desc.Height;

	return true;
}
// eNX`[̓ǂݍ
bool CreateTextureFromMemory(const void* pData, size_t size, TextureData* pOut)
{
	if( pOut == NULL ) return false;
	IDirect3DTexture9* pTexture;
	D3DXIMAGE_INFO info;

	HRESULT hr = D3DXCreateTextureFromFileInMemoryEx(
		GetDirect3DDevice(),
		pData,
		size,
		D3DX_DEFAULT,
		D3DX_DEFAULT,
		1,
		0,
		D3DFMT_A8R8G8B8,
		D3DPOOL_MANAGED,
		D3DX_FILTER_NONE,
		D3DX_DEFAULT,
		0x00000000,
		&info,
		NULL,
		&pTexture);
	if( FAILED(hr) )
	{
		return false;
	}
	D3DSURFACE_DESC desc;
	pTexture->GetLevelDesc(0, &desc);

	pOut->pTexture	= pTexture;
	pOut->srcWidth	= info.Width;
	pOut->srcHeight	= info.Height;
	pOut->width		= desc.Width;
	pOut->height	= desc.Height;

	return true;
}

// eNX`[̉
void ReleaseTexture(TextureData* pTextureData)
{
	if( pTextureData == NULL ) return;
	SAFE_RELEASE(pTextureData->pTexture);
}
